LeetCode刷题日志-153.寻找旋转排序数组中的最小值

思路:总所周知二分的逻辑非常简单,难点在边界处理。这道题我说说自己的理解, 首先二分的根本是有序,只要有序就能二分,哪怕是部分有序(这个是重点!!) 我们先搞清楚题目中的数组是通过怎样的变化得来的,基本上就是等于将整个数组向右平移(想象一个圆形的环)。重点来了,不管怎么移,数组总有一半是有序的!!要么左半边完全有序,要么右半边完全有序。 那么大家可以想想,最小值在有序的那半边还是无序的那半边。答案很显然是在无序的那半边(想想数组是如何变化得来的)。那就很简单了,每一次二分都找无序的那一半,到最后剩下的就是最小值。

java 复制代码
class Solution {
    public int findMin(int[] nums) {
        if(nums[0] <= nums[nums.length - 1])
            return nums[0];

        int left = 0;
        int right = nums.length - 1;
        int mid = -1;

        while(left < right) {
            mid = (left + right) / 2;
            if(nums[mid] > nums[right]) //判断哪边是有序的
                left = mid + 1;  //将范围缩小到无序的那一半,因为答案就在那一半。之所以要+1,是因为mid肯定不是最小的那个,至少nums[right]比nums[mid]更小
            else
                right = mid; //这里直接取mid,因为此时mid的左边(包含)是不完全有序的那一半,mid有可能直接是最小值,所以要取mid
        }
        return nums[left];
    }
}
相关推荐
老师我太想进步了20268 分钟前
【数据结构-4】算法美学之顺序表
数据结构·算法
风影同志7832422 分钟前
编码器是激活函数吗?—— 一个看起来很像、其实不是的类比
算法
UIU11426 分钟前
P1481 魔族密码
c++·算法·动态规划
文丑颜不良啊1 小时前
LeetCode1961~1980题目解析
java·leetcode
文丑颜不良啊2 小时前
LeetCode2001~2020题目解析
java·leetcode
加宝的起点雷达4 小时前
40 条候选里 38 条来自同一个源,主卡整屏重样
人工智能·算法·创业
秋天的怀念_David4 小时前
算法一千零一夜 · 第二十六夜 协议的母语
java·spring boot·算法
文丑颜不良啊5 小时前
LeetCode2021~2040题目解析
java·leetcode